//<clean=none></clean>
#ifndef dos_h
#define dos_h

#define dos_exp		0
#define dos_gau		1
#define dos_fd		2
#define dos_exp_fd 	3
#define dos_read 	5
#define dos_an		7

struct dosconfig
{
double sigma;
double edge;
double m;
int dostype;
double Nt;
double Et;
double Nt2;
double Et2;
double Eshift;
double nstart;
double nstop;
double base1;
double base2;
int npoints;
int expan_len;
double expan_N[20];
double expan_E[20];
double mu;
double tau0;
double tau1;
double Tstart;
double Tstop;
double Ngaus;
int Tsteps;
int traps;
double dband;
double detrap;
int srh_bands;
double srh_start;

double srh_sigman;
double srh_sigmap;
double srh_vth;
double Nc;
double Nv;
double srh_cut;

double del_start;
double del_stop;
double Eg;
double Xi;
double gaus_mull;
int Esteps;
};

struct dos
{
int used;
double *x;
int xlen;
int tlen;
int srh_bands;
double *t;
double *srh_E;
double *srh_den;
double **c;
double **w;
double ***srh_r1;
double ***srh_r2;
double ***srh_r3;
double ***srh_r4;
double ***srh_c;
struct dosconfig config;
};

void dos_init();
void dos_free();
double get_dos_E_n(int band,int mat);
double get_dos_E_p(int band,int mat);
void dos_free_now(struct dos *mydos);

double get_n_pop_srh(double top,double T,int trap, int mat);
double get_p_pop_srh(double top,double T,int trap, int mat);
double get_dn_pop_srh(double top,double T,int trap, int mat);
double get_dp_pop_srh(double top,double T,int trap, int mat);

void load_dos(struct device *dev,char *namen, char *namep,int mat);
double get_dn_trap_den(double top,double T,int type,int band, int mat);
double get_dp_trap_den(double top,double T,int type, int mat);
int search(double *x,int N,double find);
double get_n_srh(double top,double T,int trap,int r, int mat);
double get_dn_srh(double top,double T,int trap,int r, int mat);
double get_p_srh(double top,double T,int trap,int r, int mat);
double get_dp_srh(double top,double T,int trap,int r, int mat);
double dos_get_band_energy_n(int band, int mat);
double dos_get_band_energy_p(int band, int mat);
double dos_srh_get_fermi_p(double n, double p,int band, int mat);
double dos_srh_get_fermi_n(double n, double p,int band, int mat);
double get_Nc_free(int mat);
double get_Nv_free(int mat);
double get_n_mu(int mat);
double get_p_mu(int mat);
double get_dos_Eg(int mat);
double get_dos_Xi(int mat);

double get_dos_E_n(int band,int mat);
double get_dos_E_p(int band,int mat);
double get_n_w(double top,double T,int mat);
double get_p_w(double top,double T,int mat);
double get_top_from_n(double n,double T,int mat);
double get_top_from_p(double p,double T,int mat);
double get_n_den(double top,double T, int mat);
double get_p_den(double top,double T, int mat);
double get_n_mu(int mat);
double get_p_mu(int mat);
double get_dn_den(double top,double T, int mat);
double get_dp_den(double top,double T, int mat);
double get_dpdT_den(double top,double T,int mat);
double get_dndT_den(double top,double T,int mat);
#endif
