//<clean=none></clean>
#define BUILD_PATH "/home/roderick/solarsim/"
#ifndef sim_h
#define sim_h
#include "const.h"
#include "true_false.h"
#include <i.h>
#include "newton.h"
#include "sun.h"

#define mat_Xi		0
#define mat_Eg		1
#define mat_mue		2
#define mat_muh		3
#define mat_me		4
#define mat_mh		5
#define mat_epsilonr	6
#define mat_Dex		7
#define mat_kf		8
#define mat_a		9
#define mat_kl		10
#define mat_Xiphoton	11
#define mat_Egphoton	12
#define mat_taue0	13
#define mat_taue1	14
#define mat_tauh0	15
#define mat_tauh1	16
#define mat_A		17
#define mat_deltaE	18
#define mat_capeff      19
#define mat_br		20
#define mat_dostype	21
#define mat_rbi		22
#define version	"2.01"
//#define dumpconverge

#define dos_all		-1
#define dos_mob		0
#define dos_trap	2

#define sim_mode_jv	0
#define sim_mode_tpv	1
#define sim_mode_ce	2
#define sim_mode_li_sc	3
#define sim_mode_tpc	4
#define sim_mode_li	5
#define sim_mode_findvoc 7
#define sim_mode_jvone 	8
#define sim_mode_tof 	11
#define sim_mode_fft 	12
#define sim_mode_celiv 	14
#define sim_mode_fish	17
#define sim_mode_findlight_for_voc 18
#define sim_mode_simple_jv 20
#define sim_mode_qe 21
#define sim_mode_pulse 	22

#define tpv_mode_light 0
#define tpv_mode_voc 1

#define srh_1	1
#define srh_2	2
#define srh_3	3
#define srh_4	4

#define interface_schottky	 1


struct mesh
{
double number;
double len;
double den;
};

struct param
{
	int used;
	int len;
	double *c;
};

struct layer
{
double height;
double Nad;
char name[100];
struct param mat[100];
};

struct layers
{
int number;
struct layer* l;
};


struct newton_math_state
{
int max_electrical_itt;
double min_cur_error;
int newton_min_itt;
double electrical_clamp;
int newton_clever_exit;
};

struct device
{
	double Jnleft;
	double Jnright;
	double Jpleft;
	double Jpright;
	int fast;
	double *phi;
	double *Nad;
	double *G;
	double *Gn;
	double *Gp;
	double *n;
	double *p;
	double *dn;
	double *dndphi;
	double *dp;
	double *dpdphi;
	double *Eg;
	double *Xi;
	double *Ev;
	double *Ec;

	double *mun;
	double *mup;

	double *epsilonr;

	double *Fn;
	double *Fp;
	double *Nc;
	double *Nv;
	double *Tl;
	double *Te;
	double *Th;
	double *ymesh;
	double *R;
	double *Fi;
	int *imat;
	double *Jn;
	double *Jp;
	double Vapplied;
	int ymeshpoints;
	double Vl;
	double Vr;
	double *x;
	double *t;
	double *xp;
	double *tp;
	double *b;
	double *kf;
	double *kd;
	double *kr;
	double *a;
	double *Rbi;
	double *Rn;
	double *Rp;
	double *kl;
	double *ke;
	double *kh;
	double *Hl;
	double *He;
	double *Hh;
	double *Habs;
	double Psun;
	int dd_conv;
	int excite_conv;
	int thermal_conv;
	int newton_enable_external_thermal;

	double deltaFln;
	double deltaFlp;
	double deltaFrn;
	double deltaFrp;

	int mat_layers;
//back tracking
	double *back_x;
	double *back_xp;
	double *back_phi;
	double *back_xt;
	double *back_xpt;
	double *back_b;
	double *Rbi_k;
//back tracking end

	double *ex;
	double *Dex;
	double *Hex;

	double *nfinit;
	double *pfinit;
	double *ntinit;
	double *ptinit;

	double *nfequlib;
	double *pfequlib;
	double *ntequlib;
	double *ptequlib;

	double **ntbinit;
	double **ptbinit;

	double xlen;
	double ylen;
	double zlen;

	double kTq;

	struct layers mat;
	struct layer lcontact;
	struct layer rcontact;
	
	int N;
	int M;
	int *Ti;	//row
	int *Tj;	//col
	double *Tx;	//data
	int enable_back;

//plotting
	FILE *gnuplot;
	FILE *gnuplot_time;
	FILE *converge;
	FILE *tconverge;
	int max_electrical_itt;
	double electrical_clamp;
	int max_electrical_itt0;
	double electrical_clamp0;
	double min_cur_error;
	double Vstart;
	double Vstop;
	double Vstep;
	int Rbi_on;
	int Gp_on;
	int Gn_on;
	double Pmax_voltage;

//Device characterisation
	double Voc;
	double Jsc;
	double FF;
	double Pmax;
	double Tll;
	double Tlr;
	int Tliso;
	double dt;
	int srh_sim;
	int go_time;
	double *nlast;
	double *plast;
	int tsteps;
	double time;
	int pulsestart;
	int pulselen;
	int reprate;
	int ntrapnewton;
	int ptrapnewton;

	int stop;
	double Rshort;
	double Rshort_celiv;
	double Rshort_pulse;
	double timeshift;
	struct mesh *meshdata;
	int ymeshlayers;
	int onlypos;
	int odes;
	double last_error;
	double posclamp;
	int srh_bands;
	double *wn;
	double *wp;

//n traps
	double *nt_all;
	double **nt;
	double **ntlast;
	double **dnt;
	double **srh_n_r1;
	double **srh_n_r2;
	double **srh_n_r3;
	double **srh_n_r4;
	double **dsrh_n_r1;
	double **dsrh_n_r2;
	double **dsrh_n_r3;
	double **dsrh_n_r4;
	double **Fnt;
	double **xt;
	double *tt;

//p traps
	double *pt_all;
	double **pt;
	double **ptlast;
	double **dpt;
	double **srh_p_r1;
	double **srh_p_r2;
	double **srh_p_r3;
	double **srh_p_r4;
	double **dsrh_p_r1;
	double **dsrh_p_r2;
	double **dsrh_p_r3;
	double **dsrh_p_r4;
	double **Fpt;
	double **xpt;
	double *tpt;

	double A;
	double Vol;
	double *deltaE;
	double *capeff;

	double Rshunt;
	double Rcontact;

	int Dphoton;
	double Dphotoneff;
	int bdos;

	int *dostype;

	int interfaceleft;
	int interfaceright;
	double phibleft;
	double phibright;
	double vl_e;
	double vl_h;
	double vr_e;
	double vr_h;
	int stop_start;
	int laser;
	double externalv;
	double Vapplied_last;
	double Ilast;
	int simwire;
	int plottime;
	int timedumpcount;
	char outputpath[200];
	int simmode;
	double area;
	double tpcstop;
	double tpclaseroff;
	double tpcdtstart;
	double tpcdtmull;
	double tpclaserpower;

	double *nrelax;
	double *ntrap_to_p;
	double *prelax;
	double *ptrap_to_n;

	double tpvdtstart;
	double tpvstart;
	double tpvlaseroff;
	double tpvlaserpower;
	double tpvdtmull;
	double tpvstop;
	double tpvvoc;
	int tpvpulsestart;
	double cedtmull;
	double cetimestop;
	double cevoltage;
	double ceshortvoltage;
	int tpv_mode;
	int cefast;
	double lcharge;
	double rcharge;

	double tofstop;
	double toflaseroff;
	double tofdtstart;
	double tofdtmull;
	double toflaserpower;

	double celiv_dt;
	double celiv_t0;
	double celiv_t1;
	double celiv_t2;
	double celiv_Vexternal;
	double celiv_Vmax;
	int celiv_repeat;
	double celiv_time_j0;
	double celiv_time_j1;
	double celiv_laser_on;
	double celiv_laser_width;
	double celiv_laser_power;
	double celiv_Vss;

	double pulse_dt;
	double pulse_t0;
	double pulse_t1;
	double pulse_t2;
	double pulse_Vexternal;
	double pulse_Vmax;
	int pulse_repeat;
	double pulse_time_j0;
	double pulse_time_j1;
	double pulse_laser_on;
	double pulse_laser_width;
	double pulse_laser_power;
	double pulse_Vss;
	double pulse_light;
	double pulse_sun;

	int dumpitdos;
	double cedt;
	int cepresteps;

	double fish_1start;
	double fish_1stop;
	double fish_2start;
	double fish_2stop;
	double fish_den;
	double fish_externalv;
	double fish_dt;
	double fish_dt_mull;
	double fish_stop;
	double fish_stark;
	double fish_tstart;
	double C;
	double tpc_externalv;
	int tpc_sim_all;
	double tpc_power_suply;
	double Rtpc_short;
	double other_layers;
	int last_ittr;

	int newton_cur;
	void (*newton_aux)(struct device* ,double ,double* ,double* ,double* ,double* ,double* ,double* ,double* ,double*);
	double B;
	double doping;
	double xnl_left;
	double xpl_left;
	int stoppoint;
	double Rscope;
	double ilast;
	double ce_L;
	int newton_clever_exit;
	int slave;
	char slave_path[100];
	char plot_file[100];
	int master;
	#ifndef mindump
	double *nr1;
	double *nr2;
	double *nr3;
	double *nr4;
	#endif
	double start_stop_time;
	double tpc_L;

	double li_sc_sunstart;
	double li_sc_sunstop;
	double li_sc_sundp;
	double li_sc_sundpmul;

	double fgen;

	double Is;
	double n_id;
	double Igen;
	struct light mylight;
	int dump_movie;

	double *n_orig;
	double *p_orig;
	double *n_orig_f;
	double *p_orig_f;
	double *n_orig_t;
	double *p_orig_t;
	int nofluxl;
	double tpv_L;
	double Vbi;
	int celiv_start_at_vbi;
	int enabled;
	int fish_slicepos;
	int newton_min_itt;
};


#include "dos.h"
void newton_push_state(struct device *in);
void newton_pop_state(struct device *in);
void config_read_line_to_int(int *data,FILE *in,char *id);
void config_read_line_to_double(double *data,FILE *in,char *id);
void set_io_dump(int in);
int get_io_dump();
double get_avg_gen(struct device *in);
double get_np_tot(struct device *in);
void randomprint(char *in);
void textcolor(int color);
double newton_sim_tpv_wire(struct device *in);
void stop_start(struct device *in);
void reset_npequlib(struct device *in);
void newton_sim_jv(struct device *in);
void get_avg_np_pos(struct device *in,double *nx,double *px);
void sim_li_sc(struct device *in);

double get_background_charge(struct device *in);
void save_state(struct device *in,double to);
int load_state(struct device *in,double voltage);
void pt_extract(char *outputpath,char *infile,double T,int pt_fit,double start,double stop,double mull,double dosstart,double dosstop,int maxittr,double chop,double chop1,double norm_point,double norm_E_pos,double sigmain,double v0,double norm_E_mull);
void sim_celiv(struct device *in);
void sim_pulse(struct device *in);
void build_dft_mesh(struct istruct* out,struct istruct* in);
void build_dft_energy_mesh(struct istruct* in,double min,double max,double T);

void fft_extract();
void do_dft(struct istruct* out,struct istruct* in);
void fft_new(struct istruct* in);
void fft_to_mag(struct istruct* in,struct istruct* out);
void fft_to_phase(struct istruct* in,struct istruct* out);
void fft_to_real(struct istruct* in,struct istruct* out);
void i_to_fft(struct istruct* out,struct istruct* in);
void do_fft(struct istruct* in, int isign);


void ramp(struct device *in,double from,double to,double steps);
void dump_device_map(struct device *in);
void sim_jv_one_point(struct device *in);
void set_light_for_voc(struct device *in,double Voc);
void reset_npinit(struct device *in);
void join_tpv_to_ce(struct device *in);
double get_n_trapped_charge(struct device *in);
double get_p_trapped_charge(struct device *in);
double get_avg_recom(struct device *in);
double get_avg_recom_n(struct device *in);
double get_avg_recom_p(struct device *in);
double get_tpc_t0(char * file,double start0,double stop0,double start1,double stop1);
void sim_li(struct device *in);
double get_J_recom_n(struct device *in);
double get_J_recom_p(struct device *in);
double get_avg_k(struct device *in);

void time_init(struct device *in);
void update_arrays(struct device *in);
void tau_test(struct device *in);
void gen_dos_fd_gaus_n();
void gen_dos_fd_gaus_p();


double sim_ce(struct device *in);
void process_ce_data(int col,char *input,char *output);
double newton_charge_extraction(struct device *in);
double newton_celiv(struct device *in,double Vtot,int usecap);
double newton_sim_tpc_all(struct device *in);
double get_I_ce(struct device *in);
double get_equiv_I(struct device *in);
void sim_tpc(struct device *in);
void sim_tof(struct device *in);
void device_timestep(struct device *in);

FILE *fopena(char *path,char *name,const char *mode);
char * get_arg_plusone( char* in[],int count,char * find);
int get_arg_plusone_pos( char* in[],int count,char * find);
int scanarg( char* in[],int count,char * find);
void fit_tpv(char *file, double start, double stop,double a,double b,double c);
double get_I_recomb(struct device *in);
double wire_get_voltage_at_end();
void wire_set_dt(double dt_step);
double wire_getvoltage();
void wire_addtime();
void wire_init(double in,double timestep);
double wire_sim(double Vleft);
double newton_sim_tpv(struct device *in);
void sim_simple_jv(struct device *in);
void sim_tpv(struct device *in);
int wire();
int hashget(double *x,int N,double find);

void dump_for_plot(struct device *in);
void md5write();
int md5check();
int run_simulation_remove(char *name);
void edit_file_int(char *in_name,char *front,int line,int value);
double get_taue0(int type);
double get_taue1(int type);
double get_tauh0(int type);
double get_tauh1(int type);
double sim_externalv(struct device *in,double wantedv);
double sim_i(struct device *in,double wantedi);
void edit_file(char *in_name,char *front,int line,double value);
void dump_qe();
void dump_talbe();

double get_J_left(struct device *in);
double get_J_right(struct device *in);
double get_J_recom(struct device *in);
int fit_now();
int run_simulation(char *name);
double read_value(char *file, int skip,int line);
void copy_file(char *out_name, char *in_name,char *front,int line,double value);



double get_dark_time_error();


double dos_get_Ec_edge(int i);
double dos_get_Ev_edge(int i);
void draw_gaus(struct device *in);

void sim_jv(struct device *in);
void sim_qe(struct device *in);

double carrier_count_get_rn(struct device *in);
double carrier_count_get_rp(struct device *in);

double carrier_count_get_n(struct device *in);
double carrier_count_get_p(struct device *in);
void carrier_count_reset(struct device *in);
void carrier_count_add(struct device *in);
double get_extracted_n(struct device *in);
double get_extracted_p(struct device *in);
void device_timestep(struct device *in);
void solve_all(struct device *in);

double get_equiv_V(struct device *in);
double get_equiv_J(struct device *in);
void solver_free_memory(struct device *in);
void save_config(char *simfile,struct device *in);
void calculate_kd(struct device *in);
void update_heat(struct device *in);
void plot_now_excite(struct device *in);
double get_excite_error(struct device *in,double *b);
int solve_excite(struct device *in);
void device_update_photon_dist(struct device *in);
double B(double x);
double dB(double x);

double get_cur_error(struct device *in);
void update_solver_vars(struct device *in,int clamp);
void do_backtrack(struct device *in);
void fill_matrix(struct device *in);
void plot_open(struct device *in);
void solver_precon(int col,int nz,int *Ti,int *Tj, double *Tx,double *b);
void solver_dump_matrix(int col,int nz,int *Ti,int *Tj, double *Tx,double *b);
void device_init(struct device *in);
void load_config(char *simfile,struct device *in,int gui);
double get_I(struct device *in);
void update(struct device *cell);
int solve_cur(struct device *in);
int solve_cur_thermal(struct device *in,int thermal);
double mod(double in);
int solve_pos(struct device *in);
void get_initial(struct device *in);
double get_mat_param_lin(struct layer* in,int param,double x);
double get_mat_param(struct layer* in,int param);
double get_mat_param_poly(struct layer* in,int param,double x);
void mat_load_poly(FILE *file,struct param* in);
void load_mat_file(char *name,struct layer* in);
int solver(int col,int nz,int *Ti,int *Tj, double *Tx,double *b);
void solver_dump_matrix(int col,int nz,int *Ti,int *Tj, double *Tx,double *b);
void solver_realloc(struct device *in);
void printdebug(char *text);

void backtrak_save(struct device *in);
void backtrack_restore(struct device *in);
void plot_now(struct device *in,char *name);
void plot_close(struct device *in);
void plot_replot(struct device *in);
FILE* start_gnuplot ();
double get_J(struct device *in);
void dump_thermal(struct device *in);
int solve_thermal(struct device *in);
void device_get_memory(struct device *in);
void device_free(struct device *in);
void sim_fish(struct device *in);

//DOS model

void gen_dos_maxwell_boltzmann();
void gen_dos_fd();

void gen_dos_fd_gaus_fd();
void gen_dos_maxwell_boltzmann();


//end of DOS model
double get_charge(struct device *in);
int get_file_len(char *file_name);
double get_mat_param_mobility(struct layer* in,int param,int n);
double get_mat_param_xy(struct layer* in,int param,double x);
void mat_free(struct layer* in);
void dos_set_cap_rate(double capeff);
double get_extracted_np(struct device *in);
double get_extracted_k(struct device *in);

void rbi_test(struct device *in);
void dirty_fit();
double get_mat_param_dmobility(struct layer* in,int param,double n);

double get_bi_error(int ymeshpoints,double *b);
void solve_bi();

double get_avg_mue(struct device *in);
double get_avg_muh(struct device *in);


double get_free_n_charge(struct device *in);
double get_free_p_charge(struct device *in);
double get_free_n_charge_delta(struct device *in);
double get_free_p_charge_delta(struct device *in);
double get_total_n_trapped_charge(struct device *in);
double get_total_p_trapped_charge(struct device *in);
double get_n_trapped_charge_delta(struct device *in);
double get_p_trapped_charge_delta(struct device *in);
double get_avg_relax_n(struct device *in);
double get_avg_relax_p(struct device *in);
double get_avg_J(struct device *in);
void ramp_externalv(struct device *in,double from,double to);
void solver_free();
double get_free_np_avg(struct device *in);

double sim_voc(struct device *in);
double newton_sim_tpv_fast(struct device *in,int do_LC);
void set_ntricks_fast(int val);
void newton_sim_tpc(struct device *in);
void newton_sim_fish(struct device *in);
double get_V_TPV(struct device *in);

double get_dos_filled_n(struct device *in);
double get_dos_filled_p(struct device *in);
void inter_div(struct istruct* in,double div);

void render1d_reset();
void redner1d_slice_dump(struct device *in,int i);
int cmpstr_min(char * in1,char *in2);
int extract_str_number(char * in,char *cut);
void safe_file(char *name);
void solve_light(struct device *cell,struct light *in,double Psun_in,double Plaser_in);
#endif

